library('rjson')

import(java.time.ZonedDateTime)
import(org.springframework.http.MediaType)
import(ru.ase.multid.reports.utilities.Utilities)

source = fromJSON(param)

url = paste(source$baseURL, '/api/GetAuthors', sep = '')
rawResponse = post(url, MediaType$APPLICATION_JSON, NULL, NULL, toJSON(list(userId = source$userId)))
response = fromJSON(rawResponse)
parametersValue = list(from = source$from, to = source$to)
errorMessage = '\u041e\u0448\u0438\u0431\u043a\u0430\u0020\u043f\u0440\u0438\u0020\u0432\u044b\u0431\u043e\u0440\u043a\u0435\u0020\u0434\u0430\u043d\u043d\u044b\u0445'
dataValue = list(list(id = errorMessage, description = errorMessage, name = errorMessage, year = errorMessage,
    author = errorMessage, jenre = errorMessage))
index = 1

if (!response$error$isError) {
    authors = response$result
    bookRequestBody = list(authorId = '', locale = 'rus', userId = source$userId)
    url = paste(source$baseURL, '/api/GetList', sep = '')

    for (author in authors) {
        bookRequestBody$authorId = author$id
        rawResponse = post(url, MediaType$APPLICATION_JSON, NULL, NULL, toJSON(bookRequestBody))
        response = fromJSON(rawResponse)

        if (!response$error$isError) {
            books = response$result

            for (book in books) {
                bookPublishedDate = Utilities$parseZonedDateTime(as.character(book$publishYear))
                fromDate = Utilities$parseZonedDateTime(source$from)
                toDate = Utilities$parseZonedDateTime(source$to)

                if (!is.null(bookPublishedDate)) {
                    if (!is.null(toDate) && bookPublishedDate$isAfter(toDate)) {
                        next
                    }

                    if (!is.null(fromDate) && bookPublishedDate$isBefore(fromDate)) {
                        next
                    }
                }

                if (is.null(book$authorId_object)) {
                    authorValue = author$id
                } else {
                    authorValue = paste(book$authorId_object$lastName, book$authorId_object$name,
                        book$authorId_object$secondName)
                }

                if (is.null(book$jenreId_object)) {
                    jenreValue = book$jenreId
                } else {
                    jenreValue = book$jenreId_object$name
                }

                dataValue[[index]] = list(id = as.character(book$id), description = as.character(book$description),
                    name = as.character(book$name), year = as.character(book$publishYear),
                    author = as.character(authorValue), jenre = as.character(jenreValue))

                index = index + 1
            }
        }
    }
}

result = toJSON(list(parameters = parametersValue, data = dataValue))

result
